 file=$1
 
 # get raw data from file
 awk '/^Well/,/Derivative/{print; if(/Derivative/) exit}' $file | sed '$d' | sed '1d' > file2.tx
 
 echo temperature > temperature.tx
 grep A01 file2.tx | awk '{print $4}' | cut -c 1-5 >> temperature.tx
 cp temperature.tx raw.tx
 
 # Get well names
 for well in $(awk '{print $2}' file2.tx | uniq ) ; do
	
	echo -en "\r$well"
 
	echo $well > well.tx
	grep $well file2.tx | awk '{print $5}' >> well.tx 
	
	paste -d',' raw.tx well.tx > combined.tx
	mv combined.tx raw.tx
done

mv raw.tx raw.csv
sed '1d' raw.csv | cut -d',' -f 2- > matrix.csv
sed -n '1p' raw.csv > header.tx
sed '1d' temperature.tx > temp.tx
 
echo "
import numpy as np
import csv

def calculate_differential(matrix):
    # Calculate the number of columns in the matrix
    num_columns = matrix.shape[1]
    
    # Create an empty matrix to store the differentials
    differential_matrix = np.zeros_like(matrix)
    
    # Calculate the differential for each column
    for i in range(num_columns):
        column = matrix[:, i]
        differential = np.diff(column)
        
        # Insert the differential values into the differential matrix
        differential_matrix[1:, i] = differential
    
    return differential_matrix

# Read the CSV file and load the matrix
matrix = []
with open('matrix.csv', 'r') as file:
    csv_reader = csv.reader(file)
    for row in csv_reader:
        matrix.append([float(num) for num in row])
        
# Convert the matrix to a NumPy array
matrix = np.array(matrix)

# Calculate the differential matrix
differential_matrix = calculate_differential(matrix)

# Write the differential matrix to a new CSV file
output_file = 'differential_matrix.csv'
with open(output_file, 'w', newline='') as file:
    csv_writer = csv.writer(file)
    csv_writer.writerows(differential_matrix)


" > py.py

python3 py.py

paste -d',' temp.tx differential_matrix.csv > differential_matrix2.csv
cat header.tx differential_matrix2.csv > differential_matrix.csv
